<?php
/**
 * Yii uploader
 *
 * @author Marc Oliveras Galvez <oligalma@gmail.com> 
 * @link http://www.oligalma.com
 * @copyright 2016 Oligalma
 * @license New BSD Licence
 */

namespace app\modules\uploader;

use Yii;

class Uploader extends \yii\base\Module{
    public $controllerNamespace = 'app\modules\uploader\controllers';
    private $_assetsUrl;
	
    public function init()
    {
	parent::init();

        Yii::$app->setComponents(
	    array(
		    'db'=>array(
			'class'=>'yii\db\Connection',
			'tablePrefix' => 'tbl_',
			'dsn'=>'sqlite:'.dirname(__FILE__).'/data/uploader.sqlite',
		    ),
	    )
	);
    }
	
    public function getAssetsUrl()
    {
	if($this->_assetsUrl === null)
	{
		$assets = dirname(__FILE__) . DIRECTORY_SEPARATOR . 'assets';
		$this -> _assetsUrl = Yii::$app->getAssetManager()->publish($assets, array('beforeCopy' => 
		    function($from, $to)
		    {
			if(strpos($from, '.directory') < 1)
			  return $from;
		    }
		  ));
	}
	    
	return $this->_assetsUrl;
    }
}