<?php
/**
 * Yii uploader
 *
 * @author Marc Oliveras Galvez <oligalma@gmail.com> 
 * @link http://www.oligalma.com
 * @copyright 2016 Oligalma
 * @license New BSD Licence
 */

namespace app\modules\uploader\models;
 
use yii\db\ActiveRecord;
 
class Image extends ActiveRecord
{
    const EXCLUDE_ROOT_IMAGE_DIRECTORY = true;
    
    public $maxId = 0;

    /**
      * @return string the associated database table name
      */
    public static function tableName()
    {
	    return '{{%image}}';
    }
    
    public static function getFolders()
    {
	    $files = scandir('images');
	    foreach ($files as $key => $value) {
		if (($value === '.' && self::EXCLUDE_ROOT_IMAGE_DIRECTORY) or $value === '..' or !is_dir('images/' . $value))
			    unset($files[$key]);
	    }
	    $files = array_combine($files, $files);
	    return $files;
    }
}
